      PROGRAM TimeRebinSlide
      PARAMETER (MAXN= 20000000)           ! maximum # data samples

!  Declare arrays and some variables
      REAL*8       T(MAXN),X(MAXN),Nrebin(MAXN),Phase(MAXN)
      CHARACTER    XFILE*50,DFILE*50,WFILE*50,HEADER*80
      INTEGER      I,J,K,Ksub,Task,BINS,SubBins,N_bin(200,50),Nsum,IntTime
      REAL*8       T0,PERIOD,Ph_bin(200,50),Pherr_bin(200,50),X_bin(200,50),Xerr_bin(200,50)
      REAL*8       Exp_Bin(200,50)
      REAL*8       Phbin(2500),Pherrbin(2500),Xbin(2500),Xerrbin(2500),dPh,dPh2
      INTEGER      Nbin(2500)

      write(*,*) "TimeRebinSlide (c) Vitaly Neustroev, Version 2012-January-11"
      write(*,*) 
      WRITE (*,*) 
      write(*,*) "INPUT FILES & PARAMETERS:"
      WRITE(*,100) ' Time-series data file: '
      READ (*,*) XFILE

      WRITE(*,100) ' Period: '
      READ (*,*) Period
      WRITE(*,100) ' T0 (0=Default): '
      READ (*,*) T0
      WRITE(*,100) ' BINs (less than 201, 0 --> without binning): '
      READ (*,*) BINS
      WRITE(*,100) ' SubBins (1 --> without subbinning): '
      READ (*,*) SubBins
      IF (BINS.GT.200) BINS=200
      IF (BINS.LT.0)  BINS=0
      IF (BINS*SubBins.GT.1000) SubBins=int(1000/BINS)
      IF (SubBins.GT.50) SubBins=50
      IF (SubBins.LT.1)  SubBins=1

      WRITE (*,*) 
      WRITE (*,*) ' Please, wait '
      WRITE (*,*) 

!  Read the times T(1:N) and the data X(1:N) from XFILE
      N= MAXN                               ! defines max. N for RDDATA
      CALL RDDATA(N,T,X,XFILE)

      Do I=1,N
        Phase(I)=(T(I)-T0)/Period-INT((T(I)-T0)/Period)
      EndDo
      Call Sort2(N,Phase,X)
      CALL WRDATA(N,Phase,X,'FoldData.dat')
      IF (BINS.GT.0) THEN
        Ph_bin=0
        Pherr_bin=0
        X_bin=0
        Xerr_bin=0
        N_bin=0
        Exp_Bin=0
        Do I=1,N          
          Do Ksub=1,SubBins
             dPh=(Ksub-1.0)/Bins/SubBins+Phase(I)
             dPh2=0.
             IF (dPh.GE.1.0) THEN
               dPh=dPh-1.0
               dPh2=-1.0
             ENDIF
             J=INT(dPh*BINS)+1
!               Jcur=J+k*BINS
!               IF (Jcur.GT.SubBins*BINS) Jcur=Jcur-SubBins*BINS             
             Ph_bin(Ksub,J)=Ph_bin(Ksub,J)+Phase(I)+dPh2 !*Exposure(I)
             X_bin(Ksub,J)=X_bin(Ksub,J)+X(I)!/Exposure(I)
             N_bin(Ksub,J)=N_bin(Ksub,J)+1
          EndDo
        EndDo
        Do I=1,BINS
          Do Ksub=1,SubBins
	    IF (N_bin(Ksub,I).GT.0) Then
	      Ph_bin(Ksub,I)=Ph_bin(Ksub,I)/N_bin(Ksub,I)
	      X_bin(Ksub,I)=X_bin(Ksub,I)/N_Bin(Ksub,I)
	    Else
	      Ph_bin(Ksub,I)=0.0 !(I-0.5)/BINS
	      X_bin(Ksub,I)=0.0
	    ENDIF
!            Print *,I,Ksub,Ph_bin(Ksub,I),X_bin(Ksub,I),Xerr_bin(Ksub,I),N_bin(Ksub,I),Exp_Bin(Ksub,I)
	  EndDo
        ENDDO
        Do I=1,N
          Do Ksub=1,SubBins
             dPh=(Ksub-1.0)/Bins/SubBins+Phase(I)
             dPh2=0.
             IF (dPh.GE.1.0) Then
               dPh=dPh-1.0
               dPh2=-1.0
             EndIF
             J=INT(dPh*BINS)+1
             Pherr_bin(Ksub,J)=Pherr_bin(Ksub,J)+(Phase(I)+dPh2-Ph_bin(Ksub,J))**2
             Xerr_bin(Ksub,J)=Xerr_bin(Ksub,J)+(X(I)-X_bin(Ksub,J))**2
          EndDo 
        EndDo
        Do I=1,BINS
          Do Ksub=1,SubBins
	    IF (N_bin(Ksub,I).GT.1) Then
	      Pherr_bin(Ksub,I)=Sqrt(Pherr_bin(Ksub,I)/(N_bin(Ksub,I)-1))
	      Xerr_bin(Ksub,I)=Sqrt(Xerr_bin(Ksub,I)/(N_bin(Ksub,I)-1))
	    Else IF (N_bin(Ksub,I).EQ.1) THEN
	      Pherr_bin(Ksub,I)=Sqrt(Pherr_bin(Ksub,I))
	      Xerr_bin(Ksub,I)=Sqrt(Xerr_bin(Ksub,I))
	    ELSE
	      Pherr_bin(Ksub,I)=0
	      Xerr_bin(Ksub,I)=0
	    EndIf
	  ENDDO
	EndDo
        k=1
        Do I=1,BINS
          Do Ksub=1,SubBins
            IF (N_Bin(Ksub,I).GT.0) THEN
              Phbin(k)=Ph_bin(Ksub,I)
              Pherrbin(k)=Pherr_bin(Ksub,I)
              Xbin(k)=X_bin(Ksub,I)
              Nbin(k)=N_bin(Ksub,I)
              Xerrbin(k)=Xerr_bin(Ksub,I)/Sqrt(real(Nbin(k)))
              k=k+1
            ENDIF
          EndDo
        EndDo
        CALL WRDATA5(k-1,Phbin,Pherrbin,Xbin,Xerrbin,Nbin,'BinData.dat')
!        CALL WRDATA5(k-1,Ph_bin,Pherr_bin,X_bin,Xerr_bin,N_bin,'BinData.dat')
      ENDIF

      CALL EXIT
100   Format(a,$)
      END


      SUBROUTINE RDDATA(N,TIME,DATA,DFILE)
!----------------------------------------------------------------------------
!  Author:  J. Lehar                                         Date:  13-JUL-87
!  Written for VAX FORTRAN 77   (May require some changes for other machines)
!  Source file:  READWRITE.FOR
!----------------------------------------------------------------------------
!  Reads in the times, data values for a time series from DFILE
!  In addition, a descriptive header is read in.  N (input) specifies the
!  maximum number of samples allowed and returns (output) the number of
!  samples found.  OPEN uses UNIT=1
!     ARGUMENTS:
!         N          (input) #samples allowed, (output) #samples found
!         TIME       (output) array for time samples
!         DATA       (output) array for data samples
!         DFILE      (input) data file name
!         HEADER     (output) descriptive file header
!----------------------------------------------------------------------------
        REAL*8 TIME(N),DATA(N)
        CHARACTER DFILE*(*)

!  open the file & read in the header
        OPEN(UNIT=1,FILE=DFILE,STATUS='OLD')
!        READ(1,'(A80)') HEADER

!  read in the time series, each record has (Time,Data)
        I=1
!       step through the file until END-OF-FILE
!10         READ(1,'(2(1X,1P,E14.9))',END=11) TIME(I),DATA(I)
!10         READ(1,'(2(1X,E14.10))',END=11) TIME(I),DATA(I)
10          READ(1,*,END=11) TIME(I),DATA(I)
!           IF (TIME(I).EQ.TIME(I-1)) TYPE *, 'HERE', I, TIME(I)
!            IF (TIME(I).lt.9400.or.TIME(I).gt.9875) goto 10
!           TYPE *, TIME(I), DATA(I)
           I= I+1
           IF(I.GT.N)THEN
!              TYPE *,'RDDATA: data exceeds array size, truncating at N=',N
              GOTO 11
           ENDIF
           GOTO 10
11      CONTINUE
!        type *, 'here'
!  close the file & return the number of samples found
        CLOSE(UNIT=1)
        N= I-1
        RETURN
        END


      SUBROUTINE WRDATA(N,TIME,X,DFILE)
!----------------------------------------------------------------------------
!  Author:  J. Lehar                                         Date:  13-JUL-87
!  Written for VAX FORTRAN 77   (May require some changes for other machines)
!  Source file:  READWRITE.FOR
!----------------------------------------------------------------------------
!  Writes the times, data values for a time series from DFILE
!  In addition, a descriptive header is written. OPEN uses UNIT=1
!     ARGUMENTS:
!         N          (input) #samples
!         TIME       (input) array for time samples
!         DATA       (input) array for data samples
!         DFILE      (input) data file name
!         HEADER     (input) descriptive file header
!----------------------------------------------------------------------------
        REAL*8 TIME(N),X(N)
        CHARACTER DFILE*(*)

!  open the file & write the header
        OPEN(UNIT=1,FILE=DFILE,STATUS='UNKNOWN')

!  write the time series
        DO I=1,N
           WRITE(1,'(2(1X,F14.7))') TIME(I),X(I)
        ENDDO

!  close the file & return
        CLOSE(UNIT=1)
        RETURN
        END


      SUBROUTINE WRDATA5(N,TIME,Terr,X,Xerr,Num,DFILE)
!----------------------------------------------------------------------------
!  Author:  J. Lehar, V. Neustroev                         Date:  29-Apr-2008
!  Written for VAX FORTRAN 77   (May require some changes for other machines)
!  Source file:  READWRITE.FOR
!----------------------------------------------------------------------------
!  Writes the times, data values for a time series from DFILE
!  In addition, a descriptive header is written. OPEN uses UNIT=1
!     ARGUMENTS:
!         N          (input) #samples
!         TIME       (input) array for time samples
!         Terr       (input) array for time samples
!         X          (input) array for data samples
!         Xerr       (input) array for data samples
!         NUM        (input) array for data samples
!         DFILE      (input) data file name
!----------------------------------------------------------------------------
        REAL*8 TIME(N),Terr(N),X(N),Xerr(N)
        INTEGER Num(N)
        CHARACTER DFILE*(*)

!  open the file & write the header
        OPEN(UNIT=1,FILE=DFILE,STATUS='UNKNOWN')

!  write the time series
        DO I=1,N
           WRITE(1,'(4(1X,F14.7),i5)') TIME(I),Terr(I),X(I),Xerr(I),Num(I)
        ENDDO
        DO I=1,N
           WRITE(1,'(4(1X,F14.7),i5)') TIME(I)+1.0,Terr(I),X(I),Xerr(I),Num(I)
        ENDDO

!  close the file & return
        CLOSE(UNIT=1)
        RETURN
        END


